import { type CompletionFunc } from '@pnpm/command';
import { type Config } from '@pnpm/config';
import { type RunLifecycleHookOptions } from '@pnpm/lifecycle';
import { type ProjectManifest } from '@pnpm/types';
import { type RecursiveRunOpts } from './runRecursive';
export declare const IF_PRESENT_OPTION: {
    'if-present': BooleanConstructor;
};
export declare const IF_PRESENT_OPTION_HELP: {
    description: string;
    name: string;
};
export declare const PARALLEL_OPTION_HELP: {
    description: string;
    name: string;
};
export declare const RESUME_FROM_OPTION_HELP: {
    description: string;
    name: string;
};
export declare const SEQUENTIAL_OPTION_HELP: {
    description: string;
    name: string;
};
export declare const REPORT_SUMMARY_OPTION_HELP: {
    description: string;
    name: string;
};
export declare const shorthands: {
    parallel: string[];
    sequential: string[];
};
export declare function rcOptionsTypes(): {};
export declare function cliOptionsTypes(): {
    recursive: BooleanConstructor;
    reverse: BooleanConstructor;
    'resume-from': StringConstructor;
    'report-summary': BooleanConstructor;
    'if-present': BooleanConstructor;
};
export declare const completion: CompletionFunc;
export declare const commandNames: string[];
export declare function help(): string;
export type RunOpts = Omit<RecursiveRunOpts, 'allProjects' | 'selectedProjectsGraph' | 'workspaceDir'> & {
    recursive?: boolean;
} & Pick<Config, 'dir' | 'engineStrict' | 'extraBinPaths' | 'reporter' | 'scriptsPrependNodePath' | 'scriptShell' | 'shellEmulator' | 'enablePrePostScripts' | 'userAgent' | 'extraEnv'> & ({
    recursive?: false;
} & Partial<Pick<Config, 'allProjects' | 'selectedProjectsGraph' | 'workspaceDir'>> | {
    recursive: true;
} & Required<Pick<Config, 'allProjects' | 'selectedProjectsGraph' | 'workspaceDir'>>) & {
    argv?: {
        original: string[];
    };
    fallbackCommandUsed?: boolean;
};
export declare function handler(opts: RunOpts, params: string[]): Promise<string | void | {
    exitCode: number;
}>;
export interface RunScriptOptions {
    enablePrePostScripts: boolean;
}
export declare const runScript: (opts: {
    manifest: ProjectManifest;
    lifecycleOpts: RunLifecycleHookOptions;
    runScriptOptions: RunScriptOptions;
    passedThruArgs: string[];
}, scriptName: string) => Promise<void>;
